## biometryd 0.3.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(biometryd)

set(PROJECT_VERSION 0.3.3)

set(BIOMETRYD_VERSION_MAJOR 1)
set(BIOMETRYD_VERSION_MINOR 0)
set(BIOMETRYD_VERSION_PATCH 1)

option(ENABLE_WERROR "Treat all build warnings as errors" ON)

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -pedantic -Wextra -fPIC -fvisibility=hidden -pthread")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++17 -Wall -fno-strict-aliasing -fvisibility=hidden -fvisibility-inlines-hidden -pedantic -Wextra -fPIC -pthread -DBOOST_ASIO_DISABLE_EPOLL")
set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--no-undefined")

if(ENABLE_WERROR)
    add_compile_options("-Werror")
endif()

include(GNUInstallDirs)

set(
    BIOMETRYD_DEFAULT_PLUGIN_DIRECTORY "${CMAKE_INSTALL_FULL_LIBDIR}/biometryd/plugins"
    CACHE STRING "Default plugin installation directory")

set(
    BIOMETRYD_CUSTOM_PLUGIN_DIRECTORY "/custom/vendor/biometryd/plugins"
    CACHE STRING "Custom plugin installation directory")

enable_testing()

find_package(PkgConfig)
find_package(Boost COMPONENTS filesystem program_options REQUIRED)
find_package(nlohmann_json 3.11 REQUIRED)

pkg_check_modules(DBUS_CPP dbus-cpp REQUIRED)
pkg_check_modules(DBUS dbus-1 REQUIRED)
pkg_check_modules(LIBAPPARMOR libapparmor REQUIRED)
pkg_check_modules(PROCESS_CPP process-cpp REQUIRED)
pkg_check_modules(SQLITE3 sqlite3 REQUIRED)

# Opt-out of depending on systemd at build-time
option(USE_SYSTEMD "Install systemd service" ON)
if (USE_SYSTEMD)
    pkg_check_modules(SYSTEMD systemd)
    if (NOT SYSTEMD_FOUND)
        message(FATAL_ERROR "systemd pkg-config not found (required for figuring out service install location)")
    endif()
endif()

# Opt-in to enable hybris support
option(WITH_HYBRIS "Enable libhybris integration support" OFF)
if (WITH_HYBRIS)
    # Try to find hybris, and disable hybris from build if not found
    find_library(Hybris
        NAMES hybris-common REQUIRED
    )
endif()

include_directories(
    include
    src

    # Make sure that files generated during build are available for compilation.
    # Most notably, this refers to include/biometry/version.h
    ${CMAKE_BINARY_DIR}/include

    ${Boost_INCLUDE_DIRS}
    ${DBUS_CPP_INCLUDE_DIRS}
    ${DBUS_INCLUDE_DIRS}
    ${LIBAPPARMOR_INCLUDE_DIRS}
    ${PROCESS_CPP_INCLUDE_DIRS}
    ${SQLITE3_INCLUDE_DIRS})

add_subdirectory(data)
add_subdirectory(doc)
add_subdirectory(include)
add_subdirectory(src)
add_subdirectory(tests)

=== debian/changelog ===
biometryd (0.3.3-1) unstable; urgency=medium

  * Team upload
  * New upstream release
  * Remove obsolete Build-Depends: libboost-system-dev (Closes: #1127176)
  * Update minimum dbus-cpp & process-cpp
  * Update Standards Version to 4.7.3

 -- Jeremy Bícha <jbicha@ubuntu.com>  Fri, 20 Feb 2026 11:09:13 -0500

=== debian/control ===
Source: biometryd
Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
Uploaders: Mike Gabriel <sunweaver@debian.org>,
           Marius Gripsgard <mariogrip@debian.org>,
Build-Depends: cmake,
               cmake-extras,
               debhelper-compat (= 13),
               doxygen,
               google-mock,
               graphviz,
               libapparmor-dev,
               libboost-filesystem-dev,
               libboost-program-options-dev,
               libboost-test-dev,
               libdbus-cpp-dev (>= 5.0.6),
               libdbus-1-dev,
               libelf-dev,
               libgtest-dev,
               libprocess-cpp-dev (>= 3.0.3),
               libsqlite3-dev,
               lsb-release,
               nlohmann-json3-dev,
               pkgconf,
               qml-module-qttest,
               qtbase5-dev,
               qtdeclarative5-dev,
               qtdeclarative5-dev-tools,
               systemd-dev [linux-any],
Standards-Version: 4.7.3
Section: libs
Homepage: https://gitlab.com/ubports/development/core/biometryd/
Vcs-Git: https://salsa.debian.org/ubports-team/biometryd.git
Vcs-Browser: https://salsa.debian.org/ubports-team/biometryd

Package: libbiometry1
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends},
Depends: ${misc:Depends},
         ${shlibs:Depends},
Breaks: libbiometryd1 (<< 0.0.3~),
Replaces: libiometryd1 (<< 0.0.3~),
Recommends: biometryd-bin,
Description: biometryd mediates/multiplexes to biometric devices - runtime library
 biometryd mediates and multiplexes access to biometric devices present
 on the system, enabling applications and system components to leverage
 them for identification and verification of users.
 .
 This package includes the biometryd runtime libraries.

Package: libbiometry-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends},
Depends: libbiometry1 (= ${binary:Version}),
         ${misc:Depends},
Breaks: libbiometryd-dev (<< 0.0.3~),
Replaces: libiometryd-dev (<< 0.0.3~),
Description: biometryd mediates/multiplexes to biometric devices - development headers
 biometryd mediates and multiplexes access to biometric devices present
 on the system, enabling applications and system components to leverage
 them for identification and verification of users.
 .
 This package includes all the development headers and libraries for
 biometryd.

Package: biometryd-bin
Section: devel
Architecture: any
Multi-Arch: foreign
Depends: libbiometry1 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Description: biometryd mediates/multiplexes to biometric devices - daemon/helper binaries
 biometryd mediates and multiplexes access to biometric devices present
 on the system, enabling applications and system components to leverage
 them for identification and verification of users.
 .
 Daemon and helper binaries to be used by services.

Package: qml-module-biometryd
Section: devel
Architecture: any
Depends: libbiometry1 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Multi-Arch: same
Description: biometryd mediates/multiplexes to biometric devices - QML bindings
 biometryd mediates and multiplexes access to biometric devices present
 on the system, enabling applications and system components to leverage
 them for identification and verification of users.
 .
 This package contains the qtdeclarative bindings for biometryd.

## biometryd 0.4.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,17 +1,24 @@
-cmake_minimum_required(VERSION 3.5)
+cmake_minimum_required(VERSION 3.25)
 
-project(biometryd)
-
-set(PROJECT_VERSION 0.3.3)
+project(biometryd
+    VERSION 0.4.0
+    LANGUAGES CXX)
 
 set(BIOMETRYD_VERSION_MAJOR 1)
 set(BIOMETRYD_VERSION_MINOR 0)
 set(BIOMETRYD_VERSION_PATCH 1)
 
 option(ENABLE_WERROR "Treat all build warnings as errors" ON)
+option(ENABLE_QT6 "Enable Qt6 build" OFF)
+set(CMAKE_CXX_STANDARD 17 CACHE STRING "The C++ standard to use")
+set(CMAKE_CXX_STANDARD_REQUIRED ON)
+set(CMAKE_CXX_EXTENSIONS OFF)
 
-set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -pedantic -Wextra -fPIC -fvisibility=hidden -pthread")
-set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++17 -Wall -fno-strict-aliasing -fvisibility=hidden -fvisibility-inlines-hidden -pedantic -Wextra -fPIC -pthread -DBOOST_ASIO_DISABLE_EPOLL")
+set(THREADS_PREFER_PTHREAD_FLAG TRUE)
+find_package(Threads)
+
+set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -pedantic -Wextra -fvisibility=hidden")
+set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -fno-strict-aliasing -fvisibility=hidden -fvisibility-inlines-hidden -pedantic -Wextra")
 set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--no-undefined")
 
 if(ENABLE_WERROR)
@@ -19,6 +26,17 @@
 endif()
 
 include(GNUInstallDirs)
+
+if(ENABLE_QT6)
+    find_package(Qt6 REQUIRED COMPONENTS Core Qml Quick QuickTest)
+    set(QT_VERSION_MAJOR 6)
+    # FIXME disabled due to issue building tests with GMock if CMAKE_AUTOMOC is
+    # enabled
+    # qt_standard_project_setup()
+else()
+    find_package(Qt5 REQUIRED COMPONENTS Core Qml Quick QuickTest)
+    set(QT_VERSION_MAJOR 5)
+endif()
 
 set(
     BIOMETRYD_DEFAULT_PLUGIN_DIRECTORY "${CMAKE_INSTALL_FULL_LIBDIR}/biometryd/plugins"

=== data/CMakeLists.txt ===
configure_file(
  biometryd.conf.in biometryd.conf @ONLY
)
configure_file(
  biometryd.pc.in biometryd.pc @ONLY
)

install(
  FILES ${CMAKE_CURRENT_BINARY_DIR}/biometryd.pc
  DESTINATION ${CMAKE_INSTALL_FULL_LIBDIR}/pkgconfig
  )

install(
  FILES ${CMAKE_CURRENT_SOURCE_DIR}/com.ubports.biometryd.Service.conf
  DESTINATION ${CMAKE_INSTALL_FULL_SYSCONFDIR}/dbus-1/system.d/
)

if (USE_SYSTEMD)
    pkg_get_variable(SYSTEMD_SYSTEM_UNIT_DIR systemd systemdsystemunitdir)

    configure_file(
      biometryd.service.in biometryd.service @ONLY
    )

    install(
      FILES ${CMAKE_CURRENT_BINARY_DIR}/biometryd.service
      DESTINATION ${SYSTEMD_SYSTEM_UNIT_DIR}
    )
endif()

=== tests/CMakeLists.txt ===
configure_file(config.cpp.in config.cpp)

set(GMOCK_BUILD_SHARED_LIBS ON)
find_package(GMock)

include_directories(
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${GMOCK_INCLUDE_DIRS}
)

# Ensure that we have a ready-made fixture maintaining a private bus instance
# readily available in unit- and integration tests.
add_definitions(-DCORE_DBUS_ENABLE_GOOGLE_TEST_FIXTURE)

macro(BIOMETRYD_ADD_TEST test_name src)
  add_executable(
    ${test_name}
    ${src}
    ${CMAKE_CURRENT_SOURCE_DIR}/did_finish_successfully.h
    ${CMAKE_CURRENT_SOURCE_DIR}/echo_service.h
    ${CMAKE_CURRENT_SOURCE_DIR}/echo_service.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/config.h
    ${CMAKE_CURRENT_BINARY_DIR}/config.cpp)

  target_compile_definitions(${test_name} PRIVATE
    BOOST_ASIO_DISABLE_EPOLL)

  target_link_libraries(
    ${test_name}

    biometry

    Threads::Threads
    ${Boost_LIBRARIES}
    ${DBUS_CPP_LIBRARIES}
    ${PROCESS_CPP_LIBRARIES}
    ${CMAKE_THREAD_LIBS_INIT}

    ${ARGN}

    ${GMOCK_LIBRARIES})

  add_test(${test_name} ${CMAKE_CURRENT_BINARY_DIR}/${test_name} --gtest_filter=*-*requires*)
  set_tests_properties(${test_name} PROPERTIES ENVIRONMENT "BIOMETRYD_DBUS_SKELETON_IS_RUNNING_UNDER_TESTING=1")
endmacro(BIOMETRYD_ADD_TEST)

add_library(biometryd_devices_plugin_dl SHARED biometryd_devices_plugin_dl.cpp)
target_link_libraries(biometryd_devices_plugin_dl gtest gmock)

add_library(biometryd_devices_plugin_dl_version_mismatch SHARED biometryd_devices_plugin_dl_version_mismatch.cpp)
target_link_libraries(biometryd_devices_plugin_dl_version_mismatch gtest gmock)

BIOMETRYD_ADD_TEST(test_atomic_counter test_atomic_counter.cpp)
BIOMETRYD_ADD_TEST(test_configuration test_configuration.cpp)
BIOMETRYD_ADD_TEST(test_daemon test_daemon.cpp)
BIOMETRYD_ADD_TEST(test_device_registrar test_device_registrar.cpp)
BIOMETRYD_ADD_TEST(test_dispatching_device_and_service test_dispatching_service_and_device.cpp)
BIOMETRYD_ADD_TEST(test_dbus_codec test_dbus_codec.cpp)
BIOMETRYD_ADD_TEST(test_dbus_stub_skeleton test_dbus_stub_skeleton.cpp)
BIOMETRYD_ADD_TEST(test_dictionary test_dictionary.cpp)
BIOMETRYD_ADD_TEST(test_fingerprint_reader test_fingerprint_reader.cpp)
BIOMETRYD_ADD_TEST(test_forwarding test_forwarding.cpp)
BIOMETRYD_ADD_TEST(test_geometry test_geometry.cpp)
BIOMETRYD_ADD_TEST(test_operation test_operation.cpp)
BIOMETRYD_ADD_TEST(test_percent test_percent.cpp)
BIOMETRYD_ADD_TEST(test_plugin_device test_plugin_device.cpp)
BIOMETRYD_ADD_TEST(test_progress test_progress.cpp)
BIOMETRYD_ADD_TEST(test_user test_user.cpp)

# TODO implement verifier test, its currently empty
#BIOMETRYD_ADD_TEST(test_verifier test_verifier.cpp)

BIOMETRYD_ADD_TEST(test_cmds_config cmds/test_config.cpp)
BIOMETRYD_ADD_TEST(test_cmds_run cmds/test_run.cpp)
BIOMETRYD_ADD_TEST(test_cmds_test cmds/test_test.cpp)

if ("DEB_TARGET_ARCH" STREQUAL "powerpc")
else()
add_executable(test_qml_plugin test_qml_plugin.cpp)
target_link_libraries(test_qml_plugin
    Qt${QT_VERSION_MAJOR}::Core
    Qt${QT_VERSION_MAJOR}::Qml
    Qt${QT_VERSION_MAJOR}::Quick
    Qt${QT_VERSION_MAJOR}::QuickTest)
add_test(test_qml_plugin test_qml_plugin)
set_tests_properties(test_qml_plugin PROPERTIES ENVIRONMENT "QT_QPA_PLATFORM=minimal;QML2_IMPORT_PATH=${CMAKE_BINARY_DIR}/src/biometry/qml;BIOMETRYD_QML_ENABLE_TESTING=1")
file(GLOB BIOMETRYD_QML_TEST_FILES RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} tst_*.qml)

foreach (QML_FILE ${BIOMETRYD_QML_TEST_FILES})
    message(INFO  ${QML_FILE})
    configure_file(${QML_FILE} ${QML_FILE} COPYONLY)
  endforeach(QML_FILE)
endif()

=== src/biometry/CMakeLists.txt ===
file(GLOB_RECURSE BIOMETRYD_PUBLIC_HEADERS ${CMAKE_SOURCE_DIR}/include/*.h)

set(symbol_map "${CMAKE_SOURCE_DIR}/symbols.map")

add_subdirectory(qml)

configure_file(daemon_configuration.cpp.in daemon_configuration.cpp)

if(WITH_HYBRIS)
  set(HYBRIS_SRC
    devices/android.h
    devices/android.cpp

    hardware/biometry_fp_api.cpp
    hardware/android_hw_module.h
  )

  add_definitions(-DWITH_HYBRIS)
endif()

add_library(
  biometry SHARED

  application.cpp
  daemon.h
  daemon.cpp
  device_registrar.h
  device_registrar.cpp
  device_registry.h
  device_registry.cpp
  dispatching_service.h
  dispatching_service.cpp
  geometry.cpp
  percent.cpp
  progress.cpp
  reason.cpp
  runtime.h
  runtime.cpp
  tracing_operation_observer.h
  user.cpp
  variant.cpp
  version.cpp

  "${CMAKE_CURRENT_BINARY_DIR}/daemon_configuration.cpp"

  cmds/config.h
  cmds/config.cpp
  cmds/enroll.h
  cmds/enroll.cpp
  cmds/identify.h
  cmds/identify.cpp
  cmds/list_devices.h
  cmds/list_devices.cpp
  cmds/run.h
  cmds/run.cpp
  cmds/test.h
  cmds/test.cpp
  cmds/version.h
  cmds/version.cpp

  dbus/codec.h
  dbus/interface.h
  dbus/service.cpp
  dbus/stub/service.h
  dbus/stub/service.cpp
  dbus/stub/device.h
  dbus/stub/device.cpp
  dbus/stub/template_store.h
  dbus/stub/template_store.cpp
  dbus/stub/identifier.h
  dbus/stub/identifier.cpp
  dbus/stub/observer.h
  dbus/stub/operation.h

  dbus/skeleton/credentials_resolver.h
  dbus/skeleton/daemon_credentials_resolver.h
  dbus/skeleton/daemon_credentials_resolver.cpp
  dbus/skeleton/request_verifier.h
  dbus/skeleton/request_verifier.cpp
  dbus/skeleton/service.h
  dbus/skeleton/service.cpp
  dbus/skeleton/device.h
  dbus/skeleton/device.cpp
  dbus/skeleton/template_store.h
  dbus/skeleton/template_store.cpp
  dbus/skeleton/identifier.h
  dbus/skeleton/identifier.cpp
  dbus/skeleton/observer.h
  dbus/skeleton/operation.h

  devices/dispatching.h
  devices/dispatching.cpp
  devices/dummy.h
  devices/dummy.cpp
  devices/fingerprint_reader.cpp
  devices/forwarding.h
  devices/forwarding.cpp

  devices/plugin/device.h
  devices/plugin/device.cpp
  devices/plugin/enumerator.h
  devices/plugin/enumerator.cpp
  devices/plugin/loader.h
  devices/plugin/loader.cpp
  devices/plugin/verifier.h
  devices/plugin/verifier.cpp

  util/atomic_counter.h
  util/atomic_counter.cpp
  util/benchmark.h
  util/benchmark.cpp
  util/cli.h
  util/cli.cpp
  util/configuration.h
  util/configuration.cpp
  util/dispatcher.h
  util/dispatcher.cpp
  util/dynamic_library.h
  util/dynamic_library.cpp
  util/json_configuration_builder.h
  util/json_configuration_builder.cpp
  util/not_implemented.h
  util/not_implemented.cpp
  util/not_reachable.h
  util/not_reachable.cpp
  util/once.h
  util/property_store.h
  util/property_store.cpp
  util/statistics.h
  util/statistics.cpp
  util/streaming_configuration_builder.h
  util/synchronized.h

  bridge/bridge_defs.h
  bridge/bridge.h
  bridge/hybris_bridge_defs.h

  ${HYBRIS_SRC}

  ${BIOMETRYD_PUBLIC_HEADERS})

set_target_properties(
  biometry

  PROPERTIES
  LINK_FLAGS "${ldflags} -Wl,--version-script,${symbol_map}"
  LINK_DEPENDS ${symbol_map}
  VERSION ${BIOMETRYD_VERSION_MAJOR}.${BIOMETRYD_VERSION_MINOR}.${BIOMETRYD_VERSION_PATCH}
  SOVERSION ${BIOMETRYD_VERSION_MAJOR}
)

target_compile_definitions(biometry PRIVATE
  BOOST_ASIO_DISABLE_EPOLL)

target_link_libraries(
  biometry

  util

  Threads::Threads
  dl
  elf

  nlohmann_json::nlohmann_json
  ${Boost_LIBRARIES}
  ${DBUS_CPP_LIBRARIES}
  ${PROCESS_CPP_LIBRARIES}
  ${SQLITE3_LIBRARIES}
  ${Hybris}
)

add_executable(
  biometryd
  daemon_main.cpp)

target_link_libraries(
  biometryd

  biometry)

install(
  TARGETS biometry
  LIBRARY DESTINATION ${CMAKE_INSTALL_FULL_LIBDIR}
)

install(
  TARGETS biometryd
  RUNTIME DESTINATION ${CMAKE_INSTALL_FULL_BINDIR}
)

=== src/biometry/qml/Biometryd/CMakeLists.txt ===
# FIXME needed since qt_standard_project_setup() cannot be used due to issue
# building tests with GMock if CMAKE_AUTOMOC is enabled
# if(QT_VERSION_MAJOR LESS 6)
    set(CMAKE_AUTOMOC ON)
    set(CMAKE_INCLUDE_CURRENT_DIR ON)
# endif()

set(biometryd-qml_SOURCES
    device.h
    device.cpp
    converter.h
    converter.cpp
    fingerprint_reader.h
    fingerprint_reader.cpp
    identifier.h
    identifier.cpp
    operation.h
    operation.cpp
    service.h
    service.cpp
    template_store.h
    template_store.cpp
    user.h
    user.cpp

    plugin.h
    plugin.cpp)

if(ENABLE_QT6)
    qt_add_qml_module(biometryd-qml
        URI Biometryd
        VERSION 0.0
        SOURCES ${biometryd-qml_SOURCES}
        PLUGIN_TARGET biometryd-qml
        CLASS_NAME Plugin
        NO_GENERATE_PLUGIN_SOURCE
        NO_PLUGIN_OPTIONAL)
    qt_query_qml_module(biometryd-qml
        PLUGIN_TARGET module_plugin_target
        TARGET_PATH module_target_path
        QMLDIR module_qmldir
        TYPEINFO module_typeinfo
    )
    target_link_libraries(biometryd-qml PRIVATE
        Qt${QT_VERSION_MAJOR}::Qml
        biometry
        Threads::Threads)

    set(QML_PLUGIN_DIR "${CMAKE_INSTALL_LIBDIR}/qt${QT_VERSION_MAJOR}/qml/${module_target_path}")
    install(TARGETS "${module_plugin_target}" DESTINATION "${QML_PLUGIN_DIR}")
    install(FILES "${module_qmldir}" DESTINATION "${QML_PLUGIN_DIR}")
    install(FILES "${module_typeinfo}" DESTINATION "${QML_PLUGIN_DIR}")
else()
    add_library(
        biometryd-qml SHARED
        ${biometryd-qml_SOURCES})

    target_link_libraries(biometryd-qml biometry
        Threads::Threads
        Qt${QT_VERSION_MAJOR}::Core
        Qt${QT_VERSION_MAJOR}::Qml
        Qt${QT_VERSION_MAJOR}::Quick
    )

    # We make the module available to qml tests without
    # requiring installation of the module. With that, we
    # can test the module within the build env.
    configure_file(qmldir qmldir COPYONLY)

    set(PLUGIN_DIR ${CMAKE_INSTALL_FULL_LIBDIR}/qt${QT_VERSION_MAJOR}/qml/Biometryd)

    install(
        TARGETS biometryd-qml
        DESTINATION ${PLUGIN_DIR})

    install(
        FILES qmldir
        DESTINATION ${PLUGIN_DIR})

    if (NOT CMAKE_CROSSCOMPILING)
        add_custom_target(
            Content_generated_files ALL
            SOURCES ${CMAKE_CURRENT_BINARY_DIR}/plugins.qmltypes)

        add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/plugins.qmltypes
            COMMAND qmlplugindump -notrelocatable Biometryd 0.0 ../ > ${CMAKE_CURRENT_BINARY_DIR}/plugins.qmltypes
            DEPENDS biometryd-qml
            WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
        )
        install(
            FILES ${CMAKE_CURRENT_BINARY_DIR}/plugins.qmltypes
            DESTINATION ${PLUGIN_DIR})
    endif()
endif()

=== debian/changelog ===
biometryd (0.4.0-1) unstable; urgency=medium

  * Team upload

  [ Jeremy Bícha ]
  * New upstream release
  * Update debian/copyright*
  * Add Lintian override for use of get-orig-source
  * Add patch to fix build with boost 1.87 (Closes: #1110585)
  * Remove gcc-13 patch: no longer needed

  [ Guido Berhoerster ]
  * debian: Build packages for both Qt 5 and 6

 -- Jeremy Bícha <jbicha@ubuntu.com>  Wed, 25 Feb 2026 12:58:43 -0500

=== debian/control ===
--- 
+++ 
@@ -2,9 +2,9 @@
 Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
 Uploaders: Mike Gabriel <sunweaver@debian.org>,
            Marius Gripsgard <mariogrip@debian.org>,
-Build-Depends: cmake,
+Build-Depends: debhelper-compat (= 13),
+               cmake,
                cmake-extras,
-               debhelper-compat (= 13),
                doxygen,
                google-mock,
                graphviz,
@@ -12,8 +12,8 @@
                libboost-filesystem-dev,
                libboost-program-options-dev,
                libboost-test-dev,
-               libdbus-cpp-dev (>= 5.0.6),
                libdbus-1-dev,
+               libdbus-cpp-dev (>= 5.0.5),
                libelf-dev,
                libgtest-dev,
                libprocess-cpp-dev (>= 3.0.3),
@@ -22,6 +22,9 @@
                nlohmann-json3-dev,
                pkgconf,
                qml-module-qttest,
+               qt6-base-dev,
+               qt6-declarative-dev,
+               qt6-declarative-dev-tools,
                qtbase5-dev,
                qtdeclarative5-dev,
                qtdeclarative5-dev-tools,
@@ -86,9 +89,23 @@
          ${misc:Depends},
          ${shlibs:Depends},
 Multi-Arch: same
-Description: biometryd mediates/multiplexes to biometric devices - QML bindings
+Description: biometryd mediates/multiplexes to biometric devices - Qt 5 QML bindings
  biometryd mediates and multiplexes access to biometric devices present
  on the system, enabling applications and system components to leverage
  them for identification and verification of users.
  .
- This package contains the qtdeclarative bindings for biometryd.
+ This package contains the Qt 5 QML bindings for biometryd.
+
+Package: qml6-module-biometryd
+Section: devel
+Architecture: any
+Depends: libbiometry1 (= ${binary:Version}),
+         ${misc:Depends},
+         ${shlibs:Depends},
+Multi-Arch: same
+Description: biometryd mediates/multiplexes to biometric devices - Qt 6 QML bindings
+ biometryd mediates and multiplexes access to biometric devices present
+ on the system, enabling applications and system components to leverage
+ them for identification and verification of users.
+ .
+ This package contains the Qt 6 QML bindings for biometryd.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DPKG_GENSYMBOLS_CHECK_LEVEL=4

# We cannot use lto due to biometryds plugin system will fail
export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=-lto
include /usr/share/dpkg/default.mk

# The home directory of user buildd does not exist on the builders
export XDG_DATA_HOME=/tmp

%:
	dh $@

override_dh_auto_configure:
	# DEB_TARGET_ARCH is to avoid running qml tests on powerpc
	dh_auto_configure --builddirectory=build-qt5 --buildsystem=cmake .. -- \
	                     -DDEB_TARGET_ARCH=$(DEB_TARGET_ARCH)	\
	                     -DENABLE_WERROR=ON				\
	                     -DENABLE_QT6=OFF				\
	                     -DWITH_HYBRIS=OFF				\
	                     $(NULL)
	dh_auto_configure --builddirectory=build-qt6 --buildsystem=cmake .. -- \
	                     -DDEB_TARGET_ARCH=$(DEB_TARGET_ARCH)	\
	                     -DENABLE_WERROR=OFF			\
	                     -DENABLE_QT6=ON				\
	                     -DWITH_HYBRIS=OFF				\
	                     $(NULL)

override_dh_auto_build:
	dh_auto_build --builddirectory=build-qt5 --buildsystem=cmake ..
	dh_auto_build --builddirectory=build-qt6 --buildsystem=cmake ..

override_dh_auto_test:
	# we have seen test failures when building with 8 cores instead of 4
	dh_auto_test --builddirectory=build-qt5 --buildsystem=cmake --no-parallel ..
	dh_auto_test --builddirectory=build-qt6 --buildsystem=cmake --no-parallel ..

override_dh_auto_install:
	dh_auto_install --builddirectory=build-qt6 --buildsystem=cmake ..
	dh_auto_install --builddirectory=build-qt5 --buildsystem=cmake ..

override_dh_auto_clean:
	dh_auto_clean --builddirectory=build-qt5 --buildsystem=cmake ..
	dh_auto_clean --builddirectory=build-qt6 --buildsystem=cmake ..

get-orig-source:
	uscan --noconf --force-download --rename --download-current-version --destdir=..
